10 REM   This program reads and interprets the MailBox/GateWay
20 REM   log file and generates summary statistics. The log 
30 REM   file must be converted to all upper case before 
40 REM   processing by this program.
45 REM   Note: USERS must be replaced by a number to use BASCOM
50 REM
60 REM   Written by: Tom Hogan WB7DCH  12/31/84
70 REM
80 REM   Log File event code interpretation:
90 REM
100 REM   'C' - Connect Event.
110 REM      'A' - User connected on TNC on COMM port.
120 REM      'B' - User connected on TNC on printer port.
130 REM      'L' - User was linked via the station that just connected.
140 REM
150 REM   'G' - GateWay event.
160 REM      'A' - Connection attempted and failed. Path shown.
170 REM      'C' - Connection attempted and obtained. Path shown.
180 REM      'E' - End of GateWay event, or use.
190 REM      'S' - Start of GateWay use.
200 REM      'U' - Entry to unprotocol mode.
210 REM
220 REM   'X' - Exit event.
230 REM      'B' - User said good bye.
240 REM      'D' - User disconnected.
250 REM      'F' - User forced off by system owner.
260 REM      'T' - Timeout, forced disconnect.
270 REM
280 REM   'F' - File event. 
290 REM      'U' - File has been uploaded.
300 REM      'D' - File has been downloaded.
310 REM      'W' - Directory request.
320 REM
330 REM   'M' - Message event. 
340 REM      'F' - Message has been forwarded. Connect path shown.
350 REM      'K' - Message has been killed.
360 REM      'L' - Message headers listed.
370 REM      'R' - Message has been read.
380 REM      'S' - Message has been sent.
390 REM
400 REM		Define Indices
410	C.TIME=0	:C.A=1	:C.B=2	:X.B=3	:X.D=4	:X.T=5	:X.F=6
420	G.A=7	:G.C=8	:G.U=9	:M.L=10	:M.S=11	:M.R=12	:F.W=13	:F.U=14
430	F.D=15
440 REM
450 USERS=200
460 DIM CONNECTS%(31,25),VTOTS%(25),CALS$(USERS),BYUSER%(USERS,16)
470 INPUT "Input file name ";INFIL$
480 OPEN "I",#1,INFIL$
490 INPUT "Output file name ";OUTFIL$
500 IF OUTFIL$="" THEN 490
510 OPEN "O",#2,OUTFIL$
520 INPUT "Report Month ";RPH$
530 INPUT#1,S$
540 IF EOF(1) THEN 1210
550 REM			:REM Parse Input String
560 ET$=LEFT$(S$,1)		:REM event type
570 DAY%=VAL(MID$(S$,6,2))	:REM day of the month
580 HOUR%=VAL(MID$(S$,8,2))	:REM hour during which event occurred
590 MIN%=VAL(MID$(S$,10,2))	:REM minute at which event occurred
600 ETIME%=(60*HOUR%)+MIN%	:REM time of event in minutes
610 EST$=MID$(S$,12,1)		:REM event subtype
620 IF ET$="C" THEN 680
630 IF ET$="X" THEN 960
640 IF ET$="M" THEN 1050
650 IF ET$="G" THEN 1100
660 IF ET$="F" THEN 1150
670 GOTO 530
680 REM				<< Connect Event >> ********
690 TIMEON%=ETIME%
700 C$=MID$(S$,14)
710 L%=LEN(C$)
720 HCAL$=""				:REM Extract user call
730 FOR I = 1 TO L%
740 T$=MID$(C$,I,1)
750 IF T$=" " THEN 780
760 HCAL$=HCAL$+T$
770 NEXT I
780 REM 				Update user activity or add
790 REM				call to list if new user.
800 FOR I = 1 TO USERS
810 IF CALS$(I)="" THEN 820 ELSE 860
820 REM				End of call list - add new call
830 CALS$(I)=HCAL$
840 NUSERS=I
850 GOTO 880
860 IF CALS$(I)=HCAL$ THEN 880 ELSE 870
870 NEXT I
880 C.U.I = I
890 CONNECTS%(DAY%,HOUR%)=CONNECTS%(DAY%,HOUR%)+1
900 CONNECTS%(DAY%,24)=CONNECTS%(DAY%,24)+1
910 VTOTS%(HOUR%)=VTOTS%(HOUR%)+1
920 VTOTS%(24)=VTOTS%(24)+1
930 IF EST$="A" THEN BYUSER%(C.U.I,C.A)=BYUSER%(C.U.I,C.A)+1
940 IF EST$="B" THEN BYUSER%(C.U.I,C.B)=BYUSER%(C.U.I,C.B)+1
950 GOTO 530
960 REM				<< Exit Event >> ********
970 IF ETIME%>=TIMEON% THEN DT%=ETIME%-TIMEON% ELSE DT%=ETIME%+1440-TIMEON%
980 BYUSER%(C.U.I,C.TIME)=BYUSER%(C.U.I,C.TIME)+DT%
990 SYSTEM.TIME=SYSTEM.TIME+DT%
1000 IF EST$="B" THEN BYUSER%(C.U.I,X.B)=BYUSER%(C.U.I,X.B)+1
1010 IF EST$="D" THEN BYUSER%(C.U.I,X.D)=BYUSER%(C.U.I,X.D)+1
1020 IF EST$="F" THEN BYUSER%(C.U.I,X.F)=BYUSER%(C.U.I,X.F)+1
1030 IF EST$="T" THEN BYUSER%(C.U.I,X.T)=BYUSER%(C.U.I,X.T)+1
1040 GOTO 530
1050 REM				<< Message Event >> ********
1060 IF EST$="S"THEN BYUSER%(C.U.I,M.S)=BYUSER%(C.U.I,M.S)+1
1070 IF EST$="L"THEN BYUSER%(C.U.I,M.L)=BYUSER%(C.U.I,M.L)+1
1080 IF EST$="R" THEN BYUSER%(C.U.I,M.R)=BYUSER%(C.U.I,M.R)+1
1090 GOTO 530
1100 REM				<< GateWay Event >> ********
1110 IF EST$="A" THEN BYUSER%(C.U.I,G.A)=BYUSER%(C.U.I,G.A)+1
1120 IF EST$="C" THEN BYUSER%(C.U.I,G.C)=BYUSER%(C.U.I,G.C)+1
1130 IF EST$="U" THEN BYUSER%(C.U.I,G.U)=BYUSER%(C.U.I,G.U)+1
1140 GOTO 530
1150 REM				<< File Event >> ********
1160 IF EST$="W" THEN BYUSER%(C.U.I,F.W)=BYUSER%(C.U.I,F.W)+1
1170 IF EST$="D" THEN BYUSER%(C.U.I,F.D)=BYUSER%(C.U.I,F.D)+1
1180 IF EST$="U" THEN BYUSER%(C.U.I,F.U)=BYUSER%(C.U.I,F.U)+1
1190 GOTO 530
1200 REM		******** << Print Reports >> ********
1210 PRINT#2, "WB7DCH MailBox/GateWay Statistics for the Month of ";RPH$
1220 PRINT#2,
1230 PRINT#2, "         Connects vs. Time-of-Day vs. Date"
1240 PRINT#2,
1250 PRINT#2,"Da 00 01 02 03 04 05";" 06 07 08 09 10 11";
1260 PRINT#2," 12 13 14 15 16";
1270 PRINT#2," 17 18 19 20 21 22 23 Totl"
1280 FOR DAY = 1 TO 31
1290 IF CONNECTS%(DAY,24)=0 THEN GOTO 1380
1300 PRINT#2, USING "##";DAY;
1310 FOR HR = 0 TO 23
1320 IF CONNECTS%(DAY,HR)<>0 THEN GOTO 1350
1330 PRINT#2,"  .";
1340 GOTO 1360
1350 PRINT#2, USING "###";CONNECTS%(DAY,HR);
1360 NEXT HR
1370 PRINT#2, USING "#####";CONNECTS%(DAY,24)
1380 NEXT DAY
1390 PRINT#2, "  ";
1400 FOR HR = 0 TO 23
1410 PRINT#2, USING "###";VTOTS%(HR);
1420 NEXT HR
1430 PRINT#2, USING "#####";VTOTS%(24)
1440 PRINT#2,
1450 SYS.HRS%=INT(SYSTEM.TIME/60!)
1460 SYS.MIN%=INT(SYSTEM.TIME-(SYS.HRS%*60!))
1470 AVG.CT=SYSTEM.TIME/VTOTS%(24)
1480 AVG.US=SYSTEM.TIME/NUSERS
1490 PRINT#2, "Total System Connect Time: ";SYSTEM.TIME;" minutes   (";SYS.HRS%;
1500 PRINT#2, "hours, ";SYS.MIN%;" minutes )"
1510 PRINT#2, "Average Time per Connect: ";AVG.CT;" minutes"
1520 PRINT#2, "Average User Connect Time: ";AVG.US;" minutes"
1530 PRINT#2,
1540 REM			******** << Printout by User >> ********
1550 PRINT#2, "User      Time  C.x  2m 220 X.B X.D X.T X.F G.A G.C G.U M.L M.S M.R F.W F.U F.D"
1560 FOR I=1 TO NUSERS
1570 PRINT#2, USING "\       \##### ####";CALS$(I);BYUSER%(I,0);(BYUSER%(I,C.A)+BYUSER%(I,C.B));
1580 FOR J=1 TO 15
1590 IF BYUSER%(I,J)<>0 THEN 1600 ELSE 1620
1600 PRINT#2, USING "####";BYUSER%(I,J);
1610 GOTO 1630
1620 PRINT#2, "   .";
1630 NEXT J
1640 PRINT#2,
1650 NEXT I
1660 PRINT#2,
1670 PRINT#2,"		Legend:"
1680 PRINT#2,"			C.X - Total Connects"
1690 PRINT#2,"			2m  - Two-meter Connects"
1700 PRINT#2,"			220 - 220MHz Connects"
1710 PRINT#2,"			X.B - Exit Event - Bye"
1720 PRINT#2,"			X.D - Exit Event - Disconnect"
1730 PRINT#2,"			X.T - Exit Event - Timeout"
1740 PRINT#2,"			X.F - Exit Event - Forced off by Sysop"
1750 PRINT#2,"			G.A - GateWay Event - Unsuccessful Connect Attempt"
1760 PRINT#2,"			G.C - GateWay Event - Successful Connect"
1770 PRINT#2,"			G.U - GateWay Event - Enter Unproto Mode"
1780 PRINT#2,"			M.L - Message Event - List Message Headers"
1790 PRINT#2,"			M.S - Message Event - Send Message"
1800 PRINT#2,"			M.R - Message Event - Read Message"
1810 PRINT#2,"			F.W - File Event - List File Directories"
1820 PRINT#2,"			F.U - File Event - Upload File to MailBox"
1830 PRINT#2,"			F.D - File Event - Download File from MailBox"
1840 PRINT#2,
1850 CLOSE
1860 SYSTEM
1870 END
